#set of functions, directly/indirectly involved, in oneChannelGUI generalToolMenu
#oneChannelGUI   filteringTable filtering a tab delimited file on the basis of a list of probesets




################################################################################
#this file contains a set of function that perfomr basic R function useful for handlying microarray data.
#this function filter a table on the basis of a vector of data present in an other file
"filteringTable" <- function(){
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be filtered. This file should be tab delimited with an header."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(saving.file <- paste(tempFileName, ".filtered.by.",sep=""))
    Try(mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be used to filter the previous file.\nThis file should contain a single column with an header equal to \nthe one that should be used for filtering in the tab delimited file."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(tmp <- as.vector(unlist(strsplit(tempFileName , "/"))))
    Try(saving.file <- paste(saving.file, tmp[length(tmp)],sep=""))
    Try(myFilter<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(col.for.filter <- which(names(mySel)==names(myFilter)[1]))
    Try(mySel <- mySel[which(mySel[,col.for.filter]%in%myFilter[,1]),])
    Try(tkmessageBox(title="Table subsetting",message="Saving the filtered table."))
	  Try(FileName <- tclvalue(tkgetSaveFile(initialfile=saving.file, filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if(!nchar(FileName))
		    	return())
		Try(write.table(mySel,file=FileName,quote=FALSE,col.names=NA,sep="\t"))
   
}
################################################################################

